#!/bin/csh -f
#
# tutorial script for CNSsolve
#
# written by: Paul Adams
# copyright Yale University
#
set tutdir='doc/html/tutorial'
set lnfiles=(data/mbp/mbp.mtf \
             data/mbp/bgroup.pdb \
	     data/mbp/mbp.cv \
	     data/mbp/mbp+yb.pdb \
	     refinement_mlf/model_complete/omac \
             refinement_mlf/model_complete/model_map_1fofc.inp \
	     refinement_mlf/model_complete/generate_easy_yb.inp \
	     refinement_mlf/model_complete/minimize.inp \
	     refinement_mlf/model_complete/bgroup_yb.inp)
#
if ( ! $?CNS_SOLVE ) then
  echo "CNS_SOLVE not defined"
  echo "CNS must be correctly setup to running this tutorial script"
  exit 1
endif
#
if ( ! -d $CNS_SOLVE/$tutdir ) then
  echo "cannot find tutorial directory $CNS_SOLVE/$tutdir"
  echo "please check that you are using the correct version of CNS"
  exit 1
endif
#
foreach file ( $lnfiles )
  if ( ! -e {$file}:t ) then
    echo "linking $tutdir/$file to current directory"
    ln -s $CNS_SOLVE/$tutdir/$file .
  endif
end
#
echo "        "
echo "running:"
echo "         cns_solve < model_map_1fofc.inp > model_map_1fofc.out"
echo "        "
#
cns_solve < model_map_1fofc.inp > model_map_1fofc.out
#
echo "        "
echo "running:"
echo "         cns_solve < generate_easy_yb.inp > generate_easy_yb.out"
echo "        "
#
cns_solve < generate_easy_yb.inp > generate_easy_yb.out
#
echo "        "
echo "running:"
echo "         cns_solve < bgroup_yb.inp > bgroup_yb.out"
echo "        "
#
cns_solve < bgroup_yb.inp > bgroup_yb.out
#
echo "        "
echo "running:"
echo "         cns_solve < minimize.inp > minimize.out"
echo "        "
#
cns_solve < minimize.inp > minimize.out
#
echo "        "
#
