#!/bin/csh -f
#
# tutorial script for CNSsolve
#
# written by: Paul Adams
# copyright Yale University
#
set tutdir='doc/html/tutorial'
set lnfiles=(data/mbp/mbp.mtf \
             data/mbp/mbp.pdb \
	     data/mbp/mbp.cv \
             refinement_mlf/refine_start/rigid.inp \
	     refinement_mlf/refine_start/anneal.inp \
	     refinement_mlf/refine_start/bgroup.inp)
#
if ( ! $?CNS_SOLVE ) then
  echo "CNS_SOLVE not defined"
  echo "CNS must be correctly setup to running this tutorial script"
  exit 1
endif
#
if ( ! -d $CNS_SOLVE/$tutdir ) then
  echo "cannot find tutorial directory $CNS_SOLVE/$tutdir"
  echo "please check that you are using the correct version of CNS"
  exit 1
endif
#
foreach file ( $lnfiles )
  if ( ! -e {$file}:t ) then
    echo "linking $tutdir/$file to current directory"
    ln -s $CNS_SOLVE/$tutdir/$file .
  endif
end
#
echo "        "
echo "running:"
echo "         cns_solve < rigid.inp > rigid.out"
echo "        "
#
cns_solve < rigid.inp > rigid.out
#
echo "        "
echo "running:"
echo "         cns_solve < anneal.inp > anneal.out"
echo "        "
#
cns_solve < anneal.inp > anneal.out
#
echo "        "
echo "running:"
echo "         cns_solve < bgroup.inp > bgroup.out"
echo "        "
#
cns_solve < bgroup.inp > bgroup.out
#
echo "        "
#
