#!/bin/csh -f
#
# tutorial script for CNSsolve
#
# written by: Paul Adams
# copyright Yale University
#
set tutdir='doc/html/tutorial'
set lnfiles=(data/nsf/nsf_reb.mtf \
             data/nsf/bindividual.pdb \
             data/nsf/atp.top \
             data/nsf/atp.param \
  	     data/nsf/nsf.cv \
  	     data/nsf/mad_phase2.hkl \
             refinement_mlhl/water_pick/water_pick.inp)
#
if ( ! $?CNS_SOLVE ) then
  echo "CNS_SOLVE not defined"
  echo "CNS must be correctly setup to running this tutorial script"
  exit 1
endif
#
if ( ! -d $CNS_SOLVE/$tutdir ) then
  echo "cannot find tutorial directory $CNS_SOLVE/$tutdir"
  echo "please check that you are using the correct version of CNS"
  exit 1
endif
#
foreach file ( $lnfiles )
  if ( ! -e {$file}:t ) then
    echo "linking $tutdir/$file to current directory"
    ln -s $CNS_SOLVE/$tutdir/$file .
  endif
end
#
echo "        "
echo "running:"
echo "         cns_solve < water_pick.inp > water_pick.out"
echo "        "
#
cns_solve < water_pick.inp > water_pick.out
#
echo "        "
#
