#!/bin/csh -f
#
# tutorial script for CNSsolve
#
# written by: Paul Adams
# copyright Yale University
#
set tutdir='doc/html/tutorial'
set lnfiles=(generate/protein_dna/2bop.pdb \
             generate/protein_dna/generate_easy.inp)
#
if ( ! $?CNS_SOLVE ) then
  echo "CNS_SOLVE not defined"
  echo "CNS must be correctly setup to running this tutorial script"
  exit 1
endif
#
if ( ! -d $CNS_SOLVE/$tutdir ) then
  echo "cannot find tutorial directory $CNS_SOLVE/$tutdir"
  echo "please check that you are using the correct version of CNS"
  exit 1
endif
#
foreach file ( $lnfiles )
  if ( ! -e {$file}:t ) then
    echo "linking $tutdir/$file to current directory"
    ln -s $CNS_SOLVE/$tutdir/$file .
  endif
end
#
echo "        "
echo "running:"
echo "         fix_dna_rna < 2bop.pdb > 2bop_fix1.pdb"
echo "        "
#
               fix_dna_rna < 2bop.pdb > 2bop_fix1.pdb
#
echo "        "
echo "running:"
echo "         sed 's/ C5M THY / C5A THY /' 2bop_fix1.pdb > 2bop_fix2.pdb"
echo "        "
#
               sed 's/ C5M THY / C5A THY /' 2bop_fix1.pdb > 2bop_fix2.pdb
#
echo "        "
echo "running:"
echo "         sed 's/ HOH A / HOH W /' 2bop_fix2.pdb > 2bop_fix3.pdb"
echo "        "
#
               sed 's/ HOH A / HOH W /' 2bop_fix2.pdb > 2bop_fix3.pdb
#
echo "        "
echo "running:"
echo "         cns_solve < generate_easy.inp > generate_easy.out"
echo "        "
#
               cns_solve < generate_easy.inp > generate_easy.out
#
echo "        "
#
